<script lang="ts">
    /**
     * The panel providing information about the buildings and the unity in the district
     */
    import type { Readable, Writable } from 'svelte/store'
    import type District from '$models/District'
    import type Building from '$models/Building'
    import type Storage from '$models/Buildings/Resources/Storage'
    import type { Resources } from '$lib/resource'
    import Section from './DistrictPanel/Section.svelte'
    import Switch from './DistrictPanel/Switch.svelte'
    import Units from './DistrictPanel/Units.svelte'

    export let district: District

    const buildings: Readable<Building[]> = district?.buildings
    const resources: Writable<Resources> = district?.getResources().store

    const occurrences = (
        array: Building[],
        callback: (Building) => boolean
    ): { [key: string]: number } =>
        array
            .filter(b => callback(b))
            .reduce(
                (acc, building) => ({ ...acc, [building.name()]: ++acc[building.name()] || 1 }),
                {}
            )

    $: buildingsSections = {
        'Production buildings summary': occurrences($buildings, (b: Building) => b.isProduction()),
        'Storage buildings summary': occurrences($buildings, (b: Building) => b.isStorage()),
        Others: occurrences($buildings, (b: Building) => !b.isProduction() && !b.isStorage())
    }

    let panel = 'buildings'

    const getBuilding = (buildingName): Building => $buildings.find(b => b.name() === buildingName)

    const getStorageResource = buildingName => {
        const building = getBuilding(buildingName) as Storage

        return $resources[building.resourceName]
    }

    const buildingsAre = (buildingNames: string[], callback: (Building) => boolean): boolean =>
        !buildingNames.map(name => getBuilding(name)).some(building => !callback(building))
</script>

<header>
    <Switch bind:panel />
</header>
<main>
    <div
        class:flex={panel === 'buildings'}
        class:hidden={panel !== 'buildings'}
        id="panel-buildings"
        role="tabpanel"
        tabindex="0"
        aria-labelledby="tab-buildings"
    >
        {#each Object.keys(buildingsSections) as title, i}
            <Section {title} toggle={i === 0}>
                <table class="table-auto w-full">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th class="text-right">Amount</th>
                            {#if buildingsAre(Object.keys(buildingsSections[title]), building =>
                                building.isStorage()
                            )}
                                <th class="text-right">Total capacity</th>
                            {/if}
                        </tr>
                    </thead>
                    <tbody>
                        {#each Object.keys(buildingsSections[title]) as building}
                            <tr>
                                <td>{building}</td>
                                <td class="text-right">{buildingsSections[title][building]}</td>
                                {#if getBuilding(building).isStorage()}
                                    <td class="text-right">
                                        {getStorageResource(building).max}
                                    </td>
                                {/if}
                            </tr>
                        {/each}
                    </tbody>
                </table>
            </Section>
        {/each}
    </div>
    <div
        class:flex={panel === 'units'}
        class:hidden={panel !== 'units'}
        id="panel-units"
        role="tabpanel"
        tabindex="0"
        aria-labelledby="tab-buildings"
    >
        <Units {district} />
    </div>
</main>

<style lang="postcss">
    main {
        @apply h-[calc(100%-4.75rem)] p-4 pr-10 text-trueGray-900 dark:text-trueGray-50 overflow-auto;

        [role='tabpanel'] {
            @apply flex-col gap-y-4;

            thead {
                @apply text-left text-trueGray-500 dark:text-trueGray-400;
            }

            tbody > tr {
                @apply hover:bg-trueGray-200 hover:dark:bg-trueGray-800 transition-colors duration-100 ease-out;
            }
        }
    }
</style>
